use crate::{
    error::AppResult,
    models::{CandleExtended, CandleInterval, Trade},
};

pub mod sqlite;

#[async_trait]
pub trait Repo: Send + Sync {
    async fn upsert_candles(&self, candles: &[CandleExtended]) -> AppResult<u64>;

    async fn insert_trade(&self, trade: &Trade) -> AppResult<u64>;

    async fn get_latest_candle_from_interval(
        &self,
        pair: &str,
        interval: CandleInterval,
    ) -> AppResult<Option<CandleExtended>>;
}
